# Code Climate Rubocop Engine

[![Code Climate](https://codeclimate.com/github/codeclimate/codeclimate-rubocop/badges/gpa.svg)](https://codeclimate.com/github/codeclimate/codeclimate-rubocop)

`codeclimate-rubocop` is a Code Climate engine that wraps the [RuboCop](https://github.com/rubocop-hq/rubocop) static analysis tool. You can run it on your command line using the Code Climate CLI, or on our hosted analysis platform.

RuboCop helps you enforce many of the guidelines outlined in the community [Ruby Style Guide](https://github.com/rubocop-hq/ruby-style-guide). Most aspects of its behavior can be tweaked via various [configuration options](https://github.com/rubocop-hq/rubocop/blob/master/config/default.yml), which are set in a **.rubocop.yml** file.

You can find some basic setup instructions and links to the RuboCop OSS project below. For additional Code Climate-specific config details, check out our [RuboCop engine documentation][cc-docs-rubocop].

### Installation

1. If you haven't already, [install the Code Climate CLI](https://github.com/codeclimate/codeclimate).
2. Enable the engine by adding the following under `plugins` in your `.codeclimate.yaml`:
    ```yaml
    plugins:
      rubocop:
        enabled: true
    ```
3. You're ready to analyze! Browse into your project's folder and run `codeclimate analyze`.

## ➤ Requirements

- **[Docker](https://gitlab.com/megabyte-labs/ansible-roles/docker)**
- [CodeClimate CLI](https://github.com/codeclimate/codeclimate)

### Optional Requirements

- [DockerSlim](https://gitlab.com/megabyte-labs/ansible-roles/dockerslim) - Used for generating compact, secure images
- [Google's Container structure test](https://github.com/GoogleContainerTools/container-structure-test) - For testing the Docker images


### Building the Docker Container

Run the below make command from the root of this repository to create a local fat docker image
```shell
make image
```

### Building a Slim Container

Run the below make command from the root of this repository to create a local slim docker image
```shell
make slim
```

### Test

Run the below command from the root of this repository to test the images created by this repository.
```shell
make test
```

### Need help?

For help with RuboCop, [check out their documentation](https://github.com/rubocop-hq/rubocop).

If you're running into a Code Climate issue, first check out [our RuboCop engine docs][cc-docs-rubocop] and look over this project's [GitHub Issues](https://github.com/codeclimate/codeclimate-rubocop/issues), as your question may have already been covered. If not, [go ahead and open a support ticket with us](https://codeclimate.com/help).

[cc-docs-rubocop]: https://docs.codeclimate.com/docs/rubocop
